Codeforces 426E Sereja and Two Sequences【思维+Dp+二分】好题!

351 篇文章 2 订阅
142 篇文章 0 订阅

E. Sereja and Two Sequences
time limit per test
4 seconds
memory limit per test
512 megabytes
input
standard input
output
standard output

Sereja has two sequences a1, a2, ..., an and b1, b2, ..., bm, consisting of integers. One day Sereja got bored and he decided two play with them. The rules of the game was very simple. Sereja makes several moves, in one move he can perform one of the following actions:

  1. Choose several (at least one) first elements of sequence a (non-empty prefix of a), choose several (at least one) first elements of sequence b (non-empty prefix of b); the element of sequence a with the maximum index among the chosen ones must be equal to the element of sequence b with the maximum index among the chosen ones; remove the chosen elements from the sequences.
  2. Remove all elements of both sequences.

The first action is worth e energy units and adds one dollar to Sereja's electronic account. The second action is worth the number of energy units equal to the number of elements Sereja removed from the sequences before performing this action. After Sereja performed the second action, he gets all the money that he earned on his electronic account during the game.

Initially Sereja has s energy units and no money on his account. What maximum number of money can Sereja get? Note, the amount of Seraja's energy mustn't be negative at any time moment.

Input

The first line contains integers nmse (1 ≤ n, m ≤ 105; 1 ≤ s ≤ 3·105; 103 ≤ e ≤ 104). The second line contains n integers a1a2...an (1 ≤ ai ≤ 105). The third line contains m integers b1b2...bm (1 ≤ bi ≤ 105).

Output

Print a single integer — maximum number of money in dollars that Sereja can get.

Examples
input
5 5 100000 1000
1 2 3 4 5
3 2 4 5 1
output
3
input
3 4 3006 1000
1 2 3
1 2 4 3
output
2

题目大意:

给出一个长度为N的序列,再给出长度为M的一个序列,现在有两种操作:

①在序列1中剩余部分中选择一个数a【pos】;再在序列2中剩余部分中选择一个数b【pos2】,需要保证a【pos】==b【pos2】,然后我们将序列1中从1到pos这段数字全部删除,再将序列2中从1到pos2这段数字全部删除,并且获得无效的一个金币,需要花费体力为e.

②操作2需要花费的体力是操作1一共删除的数字的个数,然后将获得的所有无效的美元变成有效的。

问最终我们最多可以获得多少有效的金币。

最初体力为S;


思路:


①观察数据范围,我们知道,S/E的最大值最高为300.也就是说,我们最多可能获得的金币的个数为300枚。


②我们通过简单的思考可以得知,简单的贪心方案总会有纰漏,考虑到问题是求最优解,那么去想Dp,设定Dp【300(i)】【j】=x表示我们获得了i枚无效的金币,序列1已经删除到了位子j的情况下,b数组删除的最少的个数为x个。

那么不难想到状态转移方程:Dp【i】【j】=min(从位子Dp【i-1】【k】向右遍历,直到第一个b【pos】==a【j】为止)【k<j】;


③我们发现,这里Dp【i-1】【k】中我们没有必要每个k都遍历到,我们只要找到最小值即可。

那么状态转移方程优化到:Dp【i】【j】=min(从pos开始遍历,每次pos++,直到第一个b【pos】==a【j】为止)pos=min(Dp【i-1】【k】)【k<j】;

这里求pos可以维护一个二维前缀最小值,然后O(1)就可以查询的到。


④我们知道,从位子pos开始遍历,其具有单调性,那么我们将a【j】这个值在b数组中出现的位子存到数组中,然后遍历的过程进行二分查找优化即可。。

过程维护一下就行了。


Ac代码:

#include<stdio.h>
#include<string.h>
#include<vector>
using namespace std;
int a[150000],b[1500000];
vector<int>mp[150000];
int dp[325][150000];
int minn[325][150000];
int main()
{
    int n,m,A,B;
    while(~scanf("%d%d%d%d",&n,&m,&A,&B))
    {
        for(int i=1;i<=100000;i++)mp[i].clear();
        for(int i=1;i<=n;i++)scanf("%d",&a[i]);
        for(int i=1;i<=m;i++)
        {
            scanf("%d",&b[i]);
            mp[b[i]].push_back(i);
        }
        memset(minn,0,sizeof(minn));
        for(int i=1;i<=300;i++)
        {
            for(int j=0;j<=n;j++)
            {
                minn[i][j]=0x3f3f3f3f;
            }
        }
        int output=0;
        for(int i=1;i<=300;i++)
        {
            for(int j=1;j<=n;j++)
            {
                int pre=minn[i-1][j-1];
                minn[i][j]=minn[i][j-1];
                int ans=-1;
                int l=0;
                int r=mp[a[j]].size()-1;
                while(r-l>=0)
                {
                    int mid=(l+r)/2;
                    if(mp[a[j]][mid]>pre)
                    {
                        r=mid-1;
                        ans=mp[a[j]][mid];
                    }
                    else l=mid+1;
                }
                if(ans==-1)continue;
                if(i*B+j+ans<=A)output=i;
                minn[i][j]=min(minn[i][j-1],ans);
            }
        }
        printf("%d\n",output);
    }
}




  • 0
    点赞
  • 1
    收藏
    觉得还不错? 一键收藏
  • 0
    评论
东南亚位于我国倡导推进的“一带一路”海陆交汇地带,作为当今全球发展最为迅速的地区之一,近年来区域内生产总值实现了显著且稳定的增长。根据东盟主要经济体公布的最新数据,印度尼西亚2023年国内生产总值(GDP)增长5.05%;越南2023年经济增长5.05%;马来西亚2023年经济增速为3.7%;泰国2023年经济增长1.9%;新加坡2023年经济增长1.1%;柬埔寨2023年经济增速预计为5.6%。 东盟国家在“一带一路”沿线国家中的总体GDP经济规模、贸易总额与国外直接投资均为最大,因此有着举足轻重的地位和作用。当前,东盟与中国已互相成为双方最大的交易伙伴。中国-东盟贸易总额已从2013年的443亿元增长至 2023年合计超逾6.4万亿元,占中国外贸总值的15.4%。在过去20余年中,东盟国家不断在全球多变的格局里面临挑战并寻求机遇。2023东盟国家主要经济体受到国内消费、国外投资、货币政策、旅游业复苏、和大宗商品出口价企稳等方面的提振,经济显现出稳步增长态势和强韧性的潜能。 本调研报告旨在深度挖掘东南亚市场的增长潜力与发展机会,分析东南亚市场竞争态势、销售模式、客户偏好、整体市场营商环境,为国内企业出海开展业务提供客观参考意见。 本文核心内容: 市场空间:全球行业市场空间、东南亚市场发展空间。 竞争态势:全球份额,东南亚市场企业份额。 销售模式:东南亚市场销售模式、本地代理商 客户情况:东南亚本地客户及偏好分析 营商环境:东南亚营商环境分析 本文纳入的企业包括国外及印尼本土企业,以及相关上下游企业等,部分名单 QYResearch是全球知名的大型咨询公司,行业涵盖各高科技行业产业链细分市场,横跨如半导体产业链(半导体设备及零部件、半导体材料、集成电路、制造、封测、分立器件、传感器、光电器件)、光伏产业链(设备、硅料/硅片、电池片、组件、辅料支架、逆变器、电站终端)、新能源汽车产业链(动力电池及材料、电驱电控、汽车半导体/电子、整车、充电桩)、通信产业链(通信系统设备、终端设备、电子元器件、射频前端、光模块、4G/5G/6G、宽带、IoT、数字经济、AI)、先进材料产业链(金属材料、高分子材料、陶瓷材料、纳米材料等)、机械制造产业链(数控机床、工程机械、电气机械、3C自动化、工业机器人、激光、工控、无人机)、食品药品、医疗器械、农业等。邮箱:market@qyresearch.com

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值